# MCP Drupal Module Development Guidelines

## Commands
- **PHPUnit Tests**: `vendor/bin/phpunit modules/path/to/tests` (single test)
- **Code Style Check**: `vendor/bin/grumphp run` or `vendor/bin/phpcs`
- **Install Dependencies**: `composer install`
- **Drupal Test**: `./vendor/bin/phpunit --testsuite Functional`

## Code Style
- Follow **Drupal Coding Standards** (enforced via PHPCS)
- Use **PSR-4** autoloading with `Drupal\mcp` namespace
- Add `declare(strict_types=1)` to all PHP files
- Use **type hints** and **return types** consistently
- **Class naming**: `CamelCase` with `Mcp` prefix (e.g., `McpPluginBase`)
- **Method naming**: `camelCase` (e.g., `getTools()`)
- **Interface naming**: Use `Interface` suffix (e.g., `McpInterface`)
- Organize code into **PSR-4 namespaces** by feature
- Use **PHPDoc** comment blocks for all classes/methods
- Follow **Drupal plugin patterns** for extensions
- Avoid debug functions (var_dump, print_r, etc.)